
#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <stdint.h> 
#include <geeonx_public.h> 


/*#pragma enum int
#pragma library ("SDL.lib")
#pragma library ("SDLmain.lib")
#pragma library ("SDL_ttf.lib") */
#define SDL_main main 


void myapp_exa_left_selected_object(struct geeonx_appdata *myapp);


int main(void)
{


struct geeonx_object *central_pointer;   /* Pointer to structure. */
struct geeonx_window_text *g_window; /* Pointer to textblock of the windwow. */

struct geeonx_appdata *myapp;

char file_name[65];
char stream_name[65];

int exit;

char *import_pointer;


/* Get memory ... */

myapp=(struct geeonx_appdata *)calloc(1,sizeof(struct geeonx_appdata));



myapp->numberofobjects=0;

myapp->in_new_object=0;       
          
myapp->background_r=50;
myapp->background_g=50;
myapp->background_b=50;

myapp->size_r=250;
myapp->size_g=150;
myapp->size_b=0;

myapp->scroll_r=110;
myapp->scroll_g=187;
myapp->scroll_b=245;

myapp->hole_screen.x=0;
myapp->hole_screen.y=0;
myapp->hole_screen.w=1024;
myapp->hole_screen.h=600;


myapp->screen_w=1024;  /* Set video mode. */
myapp->screen_h=600;


myapp->switch_st_scroll_size=0; /* You can size windows. */

myapp->language=1; /* Chose German langugae. */
myapp->insert_modus=0; /* Set insert modus.  */
myapp->scroll_speed=3; 
myapp->active_windows=0;


/* Start SDL. */

if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK) !=0)
{
        printf("SDL can not be initialized: %s\n", SDL_GetError());

}

/* Get video surface. */

myapp->screen = SDL_SetVideoMode(myapp->screen_w,myapp->screen_h,32, SDL_SWSURFACE);

if (myapp->screen == NULL)
{
        printf("Error.");
}

/* Start SDL TTF */

if(TTF_Init()==-1)
{
    printf("TTF_Init: %s\n", TTF_GetError());
   
}


/* Start geeonx ! */

gee_start_geeonx(myapp, 0,0,"twentytwo.gee", "twentytwo.gew");

/* Set application font */


myapp->font=TTF_OpenFont("DroidSans.ttf", 11);

if(!myapp->font) {
    printf("TTF_OpenFont: %s\n", TTF_GetError());
    // handle error
}


gee_set_operators(myapp);

gee_draw_box(myapp,0,0,myapp->screen_w,myapp->screen_h,myapp->background_r,myapp->background_g,myapp->background_b);

import_pointer=gee_read_external_stream("input.txt");

/* Save big stream data. */

(myapp->object_data+32)->big_stream_address=import_pointer;


/* printf("input:%s \n", import_pointer); */

gee_draw_all_objects(myapp,1,1);    /* dito !! */

SDL_EnableKeyRepeat(0, 0);


exit=0;     			/* If 1 than exit */

while(exit==0)
{

	SDL_PollEvent(&myapp->event);
        
		
    switch (myapp->event.type)
    {
				
					
		case SDL_MOUSEBUTTONDOWN:


        if(myapp->event.button.button==SDL_BUTTON_LEFT && myapp->event.button.state==SDL_PRESSED) 
		{ 
						
						
			myapp->in_new_object=gee_test_all_objects(myapp,myapp->event.button.x, myapp->event.button.y); /* Test all objects. */
					
					
			/* Check geeonx events. */ 
						
			gee_exa_left_pressed(myapp);
						
			/* Check if window is selected and earmark it as selected */
						
			gee_select_window(myapp);  
						
						
		}
					
					
		/* Reset. */
		
		myapp->in_new_object=0; 
                
        break;
                
                
        case SDL_MOUSEBUTTONUP:
                
        if(myapp->event.button.button==SDL_BUTTON_LEFT && myapp->event.button.state==SDL_RELEASED)
		{
						
						
			myapp->in_new_object=gee_test_all_objects(myapp, myapp->event.button.x, myapp->event.button.y); /* Test all objects. */
			
			/* Check geeonx events. */ 
			
			gee_exa_left_released(myapp);
			
			/* Check your own events ! */
						
			myapp_exa_left_selected_object(myapp);
						
			/* Erase old content of button. */
						
			myapp->event.button.type=0;
						

			myapp->in_new_object=0;
		}
                
		break;
				
                
		case SDL_KEYDOWN:
		
		/* Get geeonx key data. */
                 
		gee_getfirstkeyinformation(myapp);
				
		break;
				
		case SDL_KEYUP:
		
		/* Get geeonx key and text data. */
		
		gee_getfinalkeyinformation(myapp);
				
		gee_get_text(myapp);
               
        break; 
	}
}


return(0);
}

void myapp_exa_left_selected_object(struct geeonx_appdata *myapp)
{
	
unsigned int selection;
	
selection=0;
	
/* Start examination of left click events. */
		
		
	if(myapp->in_new_object==20)
	{
		/* Close window. */
			
		gee_close_win(myapp,0);
			
			
		/* Do complete redraw. */ 
		gee_draw_all_objects(myapp,0,1);
		
	
			
	}	
			
	/* Application. */
		
	else if(myapp->in_new_object==27) 
	{
		/* Check menu selection. */
		
		selection=gee_move_out_menu(myapp, 23, 1);
			
			
		if(selection==24)  /* Close. */
		{
			gee_close(myapp);
			exit(0);
			
		}
		else if(selection==25)  /* About. */
		{
			
			myapp->in_new_object=8;
					
			/* Activate window. */
					
			gee_activate_window(myapp);
			
		}
			
			
		gee_draw_all_objects(myapp,0,1);    /* dito !! */
  
	}
		
	/* Windows. */
		
	else if(myapp->in_new_object==28) 
	{
		/* Check menu selection. */
			
		selection=gee_move_out_menu(myapp, 29, 1);
			
			
		/* Input */
			
		if(selection==30)  
		{
					
			myapp->in_new_object=10;
					
			/* Activate window. */
					
			gee_activate_window(myapp);
		}
			
		/* Content. */
			
		else if(selection==31)  
		{
				
			/* Activate window. */					
				
			myapp->in_new_object=9;
						
			gee_activate_window(myapp);

			
		}
			
		gee_draw_all_objects(myapp,0,1);    /* dito !! */
			
			
	}
		
	/* Apply. */
	
	else if(myapp->in_new_object==12)
	{
		strcpy((myapp->object_data+16)->obj_text, (myapp->object_data+11)->obj_text);
			
		/* Format new text. */
			
		gee_format_small_obj(myapp,16);
			
		/* After that do a window update. */
			            
        gee_draw_and_screenup_selected_window(myapp);                   
			
	}
}






