#!/bin/bash

echo "Geeonx installation."

if [ -f /usr/local/lib/libSDL.so ]
  then
    echo "libSDL.so detected. libSDL maybe already installed."
  else
    echo "libSDL.so not found. Do you want to install Geeonx, SDL and the corresponding libs (y/n)?"
    
	read ANSWER
	if [ "$ANSWER" == "n" ]
		then
			echo "Abort skript. Goodbye."
    else [ "$ANSWER" == "y" ]
		
apt-get install build-essential xorg-dev libudev-dev libts-dev libgl1-mesa-dev libglu1-

apt-get install mesa-dev libasound2-dev libpulse-dev libopenal-dev libogg-dev libvorbis-dev 

apt-get install libaudiofile-dev libpng12-dev libfreetype6-dev libusb-dev libdbus-1-dev zlib1g-dev libdirectfb-dev

apt-get install libx11-dev libxext-dev

ldconfig

apt-get clean

echo "Preparation finished."

echo "Now loading SDLlib sources."

echo "Download SDL 1.2.15"
wget https://www.libsdl.org/release/SDL-1.2.15.tar.gz

echo "Decompress ..."

tar -xvzf SDL-1.2.15.tar.gz

cd SDL-1.2.15


echo "Configure ..."

./configure

echo "Make ... and install"

make

make install

ldconfig

cd ..

echo "Download SDL TTF 2.0.11"

wget http://www.libsdl.org/projects/SDL_ttf/release/SDL_ttf-2.0.11.tar.gz

echo "Decompress ..."

tar -xvzf SDL_ttf-2.0.11.tar.gz

cd SDL_ttf-2.0.11

echo "Configure ..."

./configure

echo "Make ... and install"

make

make install

ldconfig

cd ..

echo "Download SDL Image 1.2.12"

wget http://www.libsdl.org/projects/SDL_image/release/SDL_image-1.2.12.tar.gz

echo "Decompress ..."

tar -xvzf SDL_image-1.2.12.tar.gz

cd SDL_image-1.2.12

echo "Configure ..."

./configure

echo "Make ... and install"

make

make install

ldconfig

cd ..

echo "Copying Geeonx to usr/local/lib."

cp -v libgeeonx.so ../../lib/

echo "Copying geeonx_public.h to usr/local/include."

cp -v geeonx_public.h ../../include/

ldconfig 

echo "Copying desktop file to usr/share/applications."

cp -v GeeonxCreator.desktop ../../../share/applications/

chmod a+rx ../../lib/libgeeonx.so

echo "Finished"

fi
fi
